;; Based on the test framework in
;; Practical Common Lisp
;; by Peter Siebel

(std:in-defpackage :pcl-unit-test (:use :std :cl))

(defvar *test-name* nil)

(macx deftest (name parameters &body body)
  `(defun ,name ,parameters
    (lett *test-name* (cons ',name *test-name*)
      ,@body)))

(def pass-fail (rzult form)
  (echo "~:[***FAIL***~;   pass   ~] ~a ~a" rzult form *test-name*)
  rzult)

(macx all-okay (&body forms)
  (with-gensym okay
    `(lett ,okay t
      ,@(mapcar (fn (form) `(unless ,form (setf ,okay nil)))
		forms)
      ,okay)))

(macx test-forms (&body forms)
  `(all-okay
     ,@(mapcar (fn (form) `(pass-fail ,form ',form))
	       forms)))

(macx errs (&body body) `(not (ignore-errors ,@body t)))

;;(deftest test-fail () (check nil))

(deftest test-pcl ()
  (test-forms
    [[2 + 2] = 4]
    ;;(not (test-fail))
    ))